#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Diagnostics;
using namespace Extensibility;
using namespace System::Windows::Forms;
using namespace System::Runtime::InteropServices;
 
namespace AdxHT_009_VC
{
    //Add-in Express Add-in Module
    [GuidAttribute("E8D9C8A7-24B8-4A84-AE65-BB567C5A0DCD"), ProgId("AdxHT_009_VC.AddinModule")]
    __gc public class AddinModule : public AddinExpress::MSO::ADXAddinModule
    {
    public:
        AddinModule(void): AddinExpress::MSO::ADXAddinModule()
        {
            InitializeComponent();
        }
        AddinModule(System::ComponentModel::IContainer *container) : components(0)
        {
            /// <summary>
            /// Required for Windows.Forms Class Composition Designer support
            /// </summary>
 
            container->Add(this);
            InitializeComponent();
        }
 
        System::ComponentModel::IContainer* GetContainer()
        {
            return components;
        }
 
        void UninstallControls()
        {
            AddinExpress::MSO::ADXAddinModule::UninstallControls();
        }
 
        [ComRegisterFunctionAttribute]
        static void AddinRegister(System::Type* t)
        {
            AddinExpress::MSO::ADXAddinModule::ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        static void AddinUnregister(System::Type* t)
        {
            AddinExpress::MSO::ADXAddinModule::ADXUnregister(t);
        }
 
    protected:
        void Dispose(Boolean disposing)
        {
            if (disposing && components)
            {
                components->Dispose();
            }
            __super::Dispose(disposing);
        }
	private: AddinExpress::MSO::ADXProjectAppEvents *  adxProjectEvents;
	private: System::ComponentModel::IContainer *  components;

    private:
        /// <summary>
        /// Required designer variable.
        /// </summary>

 
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        void InitializeComponent(void)
        {
			this->components = new System::ComponentModel::Container();
			this->adxProjectEvents = new AddinExpress::MSO::ADXProjectAppEvents(this->components);
			// 
			// adxProjectEvents
			// 
			this->adxProjectEvents->ProjectBeforeTaskChange += new AddinExpress::MSO::ADXProjectBeforeChange_EventHandler(this, adxProjectEvents_ProjectBeforeTaskChange);
			// 
			// AddinModule
			// 
			this->AddinName = S"PrjExample1 (VC)";
			this->Description = S"Handle the TaskChange event (VC)";
			this->SupportedApps = AddinExpress::MSO::ADXOfficeHostApp::ohaProject;

		}

	private: System::Void adxProjectEvents_ProjectBeforeTaskChange(System::Object *  sender, AddinExpress::MSO::ADXProjectBeforeChangeEventArgs *  e)
			 {
				MessageBox::Show(String::Concat("The task '", 
					__try_cast<MSProject::Task*>(e->get_Item())->Name, "' is being changed. (VC)"));
			 }

	};
}

